// JC Wed Mar  3 10:20:52 CET 2004 - pocitani energie. 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>
#include <map>

#ifdef _WINDOWS
	#include "wfsource.h"
	#include <io.h>
#else
	#include <unistd.h>
	#include <sys/ioctl.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include "lwfsource.h"
#endif 

#include "config.h"
#include "dspc.h"
#include "ene.h"
#include "specgraf.h"


int main(int argc, char *argv[])
{
	try
	{
		// Input device
		#ifdef _WINDOWS
			WFSource WFS;
			WFS.setDevice("/dev/dsp");
		#else
			LWFSource WFS;
		#endif
		WFS.setFormat(8000, 1, 16);
		WFS.open();

		// Features
		Ene ENE;	
	
		// Output graph
		SpecGraf SG;
		//     posY, posX, dx, dy, nbins, min_val, max_val
		// puvodne bylo SG.set(0, 0, -1, -1, BANKS, 0.0f, 50000.0f);
		SG.set(0, 0, -1, -1, ENE_BUF_SIZE, 0.0f, 50000.0f);
		
		short sgn[VECTOR_SIZE];
		float sgn_fl[VECTOR_SIZE];
		float features[1];   // pouze skalar - energie ! 
		float enebuf[ENE_BUF_SIZE]; 

		// zeroing energy buffer 
		sSet (ENE_BUF_SIZE, enebuf, 0.0); 

		int filter = 0;
		
		while(1)
		{
			WFS.read((char *)sgn, VECTOR_SIZE* sizeof(short));
			
			// shorts -> floats
			int i;
			for(i = 0; i < VECTOR_SIZE; i++)
				sgn_fl[i] = (float)sgn[i];
			
			// calculate features	
			ENE.addWaveform(sgn_fl, VECTOR_SIZE);
			while(ENE.getFeatures(features))
			{        
			    // delay energu buffer. 
 			    for (i=0; i < ENE_BUF_SIZE-1; i++)
			      enebuf[i] = enebuf[i+1];
			    // write new value to the end 
			    enebuf[ENE_BUF_SIZE-1] = features[0];

			    SG.show(enebuf);
			  //			  printf ("%f\n", features[0]); fflush(stdout); 
			}
		}
		
		WFS.close();
	}
	catch(wf_error &er)
	{
		fprintf(stderr, "Sound recording error: %s\n", er.what());
		exit(1);
	}
}
